﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net.Http.Headers;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Http.Features;
using Microsoft.AspNetCore.Mvc;
using WebApplication1.Models;

namespace WebApplication1.Controllers
{
    public class HomeController : Controller
    {
        private IHostingEnvironment hostingEnv;

        public HomeController(IHostingEnvironment env)
        {
            this.hostingEnv = env;
        }
        [HttpPost]
        public IActionResult Remove(string UploadFiles)
        {
            try
            {
                var found = false;
                var file = UploadFiles;
                    var fileSavePath = getFilename(file, getPath());
                    if (System.IO.File.Exists(fileSavePath))
                    {
                        found = true;
                        System.IO.File.Delete(fileSavePath);
                    }
            
                if (found)
                {
                    return Ok();
                }
            }
            catch (Exception e)
            {
                Response.Clear();
                Response.StatusCode = 204;
                Response.HttpContext.Features.Get<IHttpResponseFeature>().ReasonPhrase = "File removed failed";
                Response.HttpContext.Features.Get<IHttpResponseFeature>().ReasonPhrase = e.Message;
            }
            return BadRequest();
        }

        private string getPath()
        {
            return hostingEnv.WebRootPath;
        }

        private string getFilename(string file, string path)
        {
            string filename = file;
            filename = path + $@"\{filename}";
            return filename;
        }

        public IActionResult Index()
        {
            MyModel model = new MyModel();
            model.Files = new Files().getFiles();
            return View(model);
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
    public class MyModel
    {
        public List<Files> Files { get; set; }
    }
    public class Files
    {
        public string FileName { get; set; }
        public string FileType { get; set; }
        public double FileSize { get; set; }

        public List<Files> getFiles()
        {
            List<Files> list = new List<Files>();
            list.Add(new Files() { FileName = "Books", FileSize = 500000, FileType = ".png" });
            list.Add(new Files() { FileName = "Movies", FileSize = 12000, FileType = ".pdf" });
            list.Add(new Files() { FileName = "Study materials", FileSize = 500000, FileType = ".docx" });
            return list;
        }
    }
}
